#################################################################################
## Force python3
#################################################################################
import sys
if not sys.version_info.major == 3:
  raise BaseException("Wrong Python version detected.  Please ensure that you are using Python 3.")
#################################################################################

import pidfile
import daemon
import logging
import re
import os
import time
import socket
import select
import argparse
import sdnotify

# Google protocol buffer message object to be exchanged between
# this server and the client is defined in this library.
# Do not modify the library code - it is generated by the Protocol Buffer compiler.
from protobuf_src.uio_message_pb2 import UIOMessage
from google.protobuf.message import DecodeError
from ApolloSM import ApolloSM

from utilities.buddyallocation.buddy_allocator import BuddyTree

from logging.handlers import RotatingFileHandler

# Wildcard processing in directory names
from glob import glob

# Variable definitions
from utilities.definitions import PIDFILE_PATH, LOGFILE_PATH

# Helper function definitions
from utilities.helpers_cleanup import cleanup, removeFWDirectories, cleanupFWDirectoriesContent
from utilities.helpers_connection import receive
from utilities.helpers_config import read_config
from utilities.helpers_address_table import write_address_table, write_connections_file
from utilities.uhal_parser.parsers import simpleParser


# API functions
from utilities.command_cmpowerup import power_up_cm_and_send_msg_back_to_client
from utilities.command_program_fpga import program_fpga_for_uuid_and_send_msg_to_client
from utilities.command_hello import generate_uuid_and_send_to_client
from utilities.command_fw_load import load_fw_for_uuid_and_send_msg_to_client, ProcessFWDir
from utilities.command_fw_unload import unload_fw_for_uuid_and_send_msg_to_client
from utilities.command_list import (
  list_uuids_and_send_msg_to_client,
  list_uio_devices_and_send_msg_back_to_client,
)


def process_incoming_message(connection, config, loaded_nodes, baMap, sm_instance, fds_to_track):
  """
  Process the incoming message from client. 
  
  Depending on the type of message received, this function will call the 
  respective function to handle the incoming request and send a response
  back to the client.

  Checkout documentation in README.md for the type of supported commands.
  """
  # Receive first 4 bytes of the message, which is the message size.
  header = receive(connection, 4)
  msgsize = int.from_bytes(header, byteorder='little', signed=False)

  # Message size is 0, client has shut down the connection, remove it from the list
  # of file descriptors we follow.
  if not msgsize:
    fds_to_track.remove(connection)
    return
  
  # Incoming message object. We'll parse the incoming message and fill this message object
  # with string and (potentially) bytes data, if a file is sent together with the message.
  incoming_message = UIOMessage()

  # Receive the main body of the message, the number of bytes expected is read from the message header,
  # and given as an argument to this function ("incoming_messagesize").
  message = receive(connection, msgsize)

  # If we received a message parse it and save the bytes data to tar.gz file
  if message:
    try:
      # Parse byte string message, skip if we fail to do so
      # Note that ParseFromString() call will fill .strdata and .bytesdata
      # attributes of the msg object, which are used below.
      bytesparsed = incoming_message.ParseFromString(message)
    except DecodeError:
      logging.error("Could not parse the incoming message, skipping.")
      return
      
    # Interpret the incoming message
    logging.info(f"String message received: {incoming_message.strdata} ({bytesparsed} bytes)")
    
    # Initialize the outgoing message we'll send to the client
    outgoing_message = UIOMessage()
    
    connections_file_name     = config["connections_file_name"]
    address_apollo_file_name  = config["address_apollo_file_name"]
    address_table_path        = config["address_table_path"]
    tarball_target_path       = config["tarball_target_path"]
    emp_config                = config["emp_config"]
    devices_config            = config["devices_config"]

    # HELLO message -> Generate UUID for client
    if incoming_message.strdata == "HELLO":
      generate_uuid_and_send_to_client(connection, outgoing_message)

    # Load FW command is passed to the server
    elif re.match("^LOAD.*", incoming_message.strdata):
      load_fw_for_uuid_and_send_msg_to_client(connection, incoming_message, outgoing_message, loaded_nodes, baMap, 
                                              connections_file_name, 
                                              address_apollo_file_name, 
                                              address_table_path, 
                                              tarball_target_path,
                                              devices_config,
                                              emp_config
                                              )
    
    # Unload FW command is passed to the server
    elif re.match("^UNLOAD.*", incoming_message.strdata):
      unload_fw_for_uuid_and_send_msg_to_client(connection, incoming_message, outgoing_message, loaded_nodes, baMap, 
                                                connections_file_name,
                                                address_apollo_file_name,
                                                address_table_path,
                                                tarball_target_path,
                                                devices_config,
                                                emp_config
                                                )

    # List the UUIDs that loaded FW/overlays
    elif incoming_message.strdata == "UIDS":
      list_uuids_and_send_msg_to_client(connection, outgoing_message)

    # Program the FPGA
    elif re.match("^PROGRAM.*", incoming_message.strdata):
      program_fpga_for_uuid_and_send_msg_to_client(connection, incoming_message, outgoing_message, config["plxvc"], sm_instance, tarball_target_path)

    # List UIO devices
    elif incoming_message.strdata == "DEVICES":
      list_uio_devices_and_send_msg_back_to_client(connection, loaded_nodes, outgoing_message)

    # Power up the CM
    elif re.match("^CMPWRUP.*", incoming_message.strdata):
      power_up_cm_and_send_msg_back_to_client(connection, incoming_message, outgoing_message, config["cmpwrup_timeout"], sm_instance)


def func_daemon(args):
  """
  Main function ran by the daemon.
  """
  logging.info("Execution started.")

  # Dictionary to store successfully loaded nodes
  loaded_nodes = {}

  # structure of allocated spaces
  # 2**32 address space of uhal 32bit words
  # 2**10 minimum size of the allocation set by axi 4K min byte address in 32bit words
  baMap = BuddyTree(2**32,2**10)
  
  # Load configuration
  config = read_config()
  devices_config = config["devices_config"]

  # 1) Cleanup. Remove previous FW directories if they already exist.
  # FW directories can still be there after the server shuts down if the
  # server didn't have enough time to cleanup.
  dirs_to_remove = [config["tarball_target_path"]]
  removeFWDirectories(dirs_to_remove)

  # Parent address tables dir has to be kept
  dirs_to_cleanup = [config["address_table_path"]]
  cleanupFWDirectoriesContent(dirs_to_cleanup)
  
  # fw udm dir should be created at the daemon startup
  # If this output directory exists, we won't try to override
  if  not os.path.exists(config["tarball_target_path"]):
    os.makedirs(config["tarball_target_path"])

  # 2) Create the address table path from scratch. Generate the connections_file_name file
  # and save it to this directory.
  write_connections_file(config["address_table_path"], config["address_apollo_file_name"], config["connections_file_name"])

  # 3) Process the firmware dtbo and address table files for the ones we want 
  # to load on boot automatically
  for directory_expression in config['load_on_boot']:
    # If the expression is a wildcard, process that
    directories = glob(directory_expression)
    for directory in directories:
      loaded_nodes.update(ProcessFWDir(directory, config['address_table_path'], config["address_apollo_file_name"], baMap, devices_config))


  # logging.debug('--- PRINTING LOADED NODES DICT ---')
  # logging.debug(loaded_nodes)
  # logging.debug('----------------------------------')

  # 4) Write XML address table with all the loaded nodes in step 3)
  address_table_path = os.path.join(config["address_table_path"], config["address_apollo_file_name"])
  write_address_table(address_table_path, loaded_nodes,baMap)

  # Create an ApolloSM instance for IO operations (e.g. powering up CM, programming FPGA)
  connections_file = os.path.join(config["address_table_path"], config["connections_file_name"])
  try:
    sm_instance = ApolloSM([connections_file])

  except RuntimeError:
    logging.error(f"Failed to create an ApolloSM from: {connections_file}")
    logging.error("Exiting func_daemon().")
    return

  logging.info(f"Created ApolloSM with connections file: {connections_file}")

  socket_path = config["socket_file"]

  # Get the directory part of the file path
  socket_directory = os.path.dirname(socket_path)

  # Create all directories if they don't already exist
  if socket_directory:  # Ensure the file has a directory part
      os.makedirs(socket_directory, exist_ok=True)

  logging.info(f"Directories for {socket_path} have been created.")

  # Set up the socket
  logging.info(f"Setting up the socket in path: {os.path.abspath(socket_path)}")

  # Check if the socket path already exists, delete it if that's the case
  if os.path.exists(socket_path):
    logging.info(f"Socket file already exists under {os.path.abspath(socket_path)}")
    logging.info(f"Removing this socket file.")
    os.unlink(socket_path)

  server = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
  server.bind(socket_path)
  server.listen()

  logging.info(f"Listening on the socket: {os.path.abspath(socket_path)}")

  # Inform systemd that we've finished our startup sequence...
  n = sdnotify.SystemdNotifier()
  n.notify("READY=1")
  
  # List of file descriptors we want to keep track of
  fds_to_track = [server]

  while True:
    try:
      # Check if the server socket is readable, timeout is 5 seconds
      readable, _, _ = select.select(fds_to_track, [], [], 5.0)

      # Server file descriptor is readable, this means we have a new connection
      if server in readable:
        # Accept the incoming connection
        connection, address = server.accept()

        # Add this to the list of file descriptors we track and go back to the select() call
        fds_to_track.append(connection)
        continue

      # Loop over the other file descriptors:
      # If any of them is readable (i.e. they are sending data), process the incoming data.
      for i in range(1,len(fds_to_track)):
        if fds_to_track[i] in readable:

          # Process the incoming message from this client
          process_incoming_message(fds_to_track[i], config, loaded_nodes, baMap, sm_instance, fds_to_track)

    # Got a SIGINT, shut down
    except KeyboardInterrupt:
      logging.debug("Shutdown requested via SIGINT.")
      break

  # Cleanup for all UUIDs
  cleanup("all")

  # Remove or cleanup FW directories as the server is shutting down
  removeFWDirectories(dirs_to_remove)
  cleanupFWDirectoriesContent(dirs_to_cleanup)

  # Shut down the server
  logging.info("Shutting down the server.")
  server.close()
  logging.info(f"Removing socket: {os.path.abspath(socket_path)}.")
  os.unlink(socket_path)
  logging.info("Shutdown complete.")
  sys.exit(0)


if __name__ == "__main__":
  parser = argparse.ArgumentParser()
  parser.add_argument("--nodaemon", help="Don't daemonize this process",action="count",default=0)
  args = parser.parse_args()

  # The logging is set up using the RotatingFileHandler so that
  # maximum log file size is 10MB. There will be 2 backup files for older logs.
  logging_format = "[%(asctime)s] %(levelname)-8s %(message)s"

  if args.nodaemon > 0:
    print("Not running as a daemon")
    logging.basicConfig(level=logging.DEBUG, format=logging_format, handlers=[
      RotatingFileHandler(LOGFILE_PATH, backupCount=2, maxBytes=10 * 1024**2)
    ])
    func_daemon(args)
  else:
    with daemon.DaemonContext(working_directory="/tmp/", pidfile=pidfile.PIDFile(PIDFILE_PATH)) as context:
      logging.basicConfig(level=logging.DEBUG, format=logging_format, handlers=[
        RotatingFileHandler(LOGFILE_PATH, backupCount=2, maxBytes=10 * 1024**2)
      ])
      func_daemon(args)
